PROJNAME = iup
LIBNAME = iup

ifeq "$(LOCALOBJ)" "Yes"
  ifeq "$(TEC_SYSNAME)" "Win32"
    OBJROOT = c:/tmp/$(USER)/obj/$(PROJNAME)/$(LIBNAME)
  else
    OBJROOT = /tmp/$(USER)/obj/$(PROJNAME)/$(LIBNAME)
  endif
endif

INCLUDES = ../include .

SRC    = idialogs.c ienv.c inames.c ikey.c ifunc.c ilex.c iparse.c \
         icall.c icalcsize.c itree.c ientdados.c icpi.c ipredial.c iup.c \
         ifocus.c imask.c itable.c icreate.c itraverse.c 
IEXPINC = iup.h iupcpi.h iupkey.h iupcbs.h iupcompat.h iupdef.h
INC    = imask.h ilex.h idrv.h ipredial.h iglobal.h ifiledlg.h \
         icall.h imacros.h itable.h itimer.h itree.h 

ifeq "$(TEC_SYSNAME)" "Win32"

  SRC +=  win/win.c win/winfiledlg.c win/winbutton.c win/wintoggle.c \
  win/winframe.c win/wincreat.c win/windlg.c win/windraw.c win/winget.c \
  win/winicon.c win/winmain.c win/winkey.c win/winmngr.c win/winedit.c \
  win/winproc.c win/winresiz.c win/winset.c win/winsize.c win/winutil.c \
  win/winver.c win/winhelp.c win/wintips.c win/windestroy.c win/wintimer.c \
  win/winglobal.c win/winhook.c win/wincombo.c

  INC += win/win.h win/winbutton.h win/wintoggle.h \
  win/winframe.h win/wincreat.h win/winicon.h \
  win/winproc.h win/winprops.h win/winresiz.h \
  win/wintips.h win/winutil.h win/winglobal.h win/winhook.h

  INCLUDES += win

  DEFINES += _WIN32_WINNT=0x0400
else
  SRC += mot/motcreat.c mot/motget.c \
  mot/motif.c mot/motkey.c mot/motproc.c mot/motresiz.c \
  mot/motset.c mot/mottips.c mot/motfiledlg.c mot/mothelp.c mot/Canvas.c \
  mot/motcolor.c mot/motglobal.c mot/mottimer.c mot/motmsgdlg.c

  INC += mot/mottips.h mot/motif.h mot/Canvas.h mot/CanvasP.h

  INCLUDES += mot
  
  USE_MOTIF=Yes   
  
  # Define to use Motif 1.x
  ifdef USE_MOTIF1
    SRC += mot/ComboBox1.c 
  endif
endif

ifeq "$(TEC_SYSNAME)" "SunOS"
  # Necessary or the fileopen will not work in SunOS
  DEFINES += NO_PATH_MODE_RELATIVE
endif

ifneq ($(findstring dll, $(TEC_UNAME)), )
  DEFINES += _IUPDLL
endif

ifeq "$(TEC_UNAME)" "owc1"
  # Necessary or IUP will not work in Open Watcom (needs test for version 2.0.1)
  FLAGS = -d2
endif
